/**
 * Author: Maxim Deb Natkh (debnatkh@gmail.com)
 * Date: 29.02.2020
 */

#include <bits/stdc++.h>
#define int long long
#define x first
#define y second
#define getbit(x, i) (((x) >> (i)) & 1)
using namespace std;
typedef pair<int, int> pii;

const int MAXN = 1e6+10;
const int INF = 1e18;
int bal[MAXN], dp[MAXN];

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    int n;
    cin >> n;
    string s;
    cin >> s;
    if (count(s.begin(), s.end(), '(') != count(s.begin(), s.end(), ')')) {
        cout << -1 << endl;
        return 0;
    }

    bal[0] = 0;
    for (int i = 0; i < s.size(); ++i) {
        bal[i + 1] = bal[i] + (s[i] == '(' ? 1 : -1);
    }
    dp[0] = 0;
    for (int i = 1; i <= n; i++) {
        dp[i] = INF;
        if (bal[i] < 0) {
            dp[i] = INF;
        } else {
            if (bal[i - 1] >= 0 && bal[i] >= 0) {
                dp[i] = dp[i - 1];
            }
            for (int j = i; j >= 0; j--) {
                if (dp[i] < i - j) break;
                if (bal[j] <= bal[i]) {
                    dp[i] = min(dp[i], dp[j] + (i - j));
                }
            }
        }
    }
    cout << dp[n] << endl;

    return 0;
}
